package org.util.Principal;

import java.util.InputMismatchException;
import java.util.Scanner;

import org.util.dao.*;

public class Principal {


	public static void main (String[] args){
		Scanner in = new Scanner (System.in);
		int s = 0;

		do{
			try{
				System.out.println ("Escolha uma opo"
						+ "\n1 - Incluso e Alterao Cadastral"
						+ "\n2 - Consulta e Exluso"
						+ "\n3 - Simulao - Sistema Price"
						+ "\n4 - Simulao - Tabela SAC"
						+ "\n5 - Sair do Sistema");
				s = Integer.parseInt(in.nextLine());
			} catch (InputMismatchException e){
				System.out.println ("Tipo de dado no corresponde ao solicitado.");
			}
		}while (s<1 || s > 5);
		switch (s){
		case 1:
			inserirDados();
			break;
		case 2:
			consultarDados();
			break;
		case 3:
			tabelaPrice();
			break;
		case 4:
			tabelaSac();
			break;
		case 5:
			System.out.println ("Sistema finalizado.");
		}

		in.close();
	}

	public static void inserirDados (){
		JDBCCadastroDAO dadosCliente = new JDBCCadastroDAO();
		Scanner in = new Scanner (System.in);
		int s = 0;
		do{
			try{
				System.out.println ("Escolha o Parmetro Cadastral: \n"
						+ "1 - Incluso\n"
						+ "2 - Alterao");
				s = Integer.parseInt(in.nextLine());
				if (s!=1 && s!=2){
					System.out.println ("Parmetro de consulta incorreto");
				}
			}catch (InputMismatchException e){
				System.out.println("Tipo de consulta no correspondente s opes apresentadas");
				in.next();
			}
		}while (s!=1 && s!=2);
		switch (s){
		case 1:
			dadosCliente.insert();
			break;
		case 2:
			dadosCliente.update();
			break;
		}
		in.close();
		System.out.println ("Dados cadastrados com sucesso!");
	}

	public static void consultarDados(){
		JDBCPesquisaDadosDAO rsPesquisa = new JDBCPesquisaDadosDAO();
		Scanner in = new Scanner (System.in);
		int s=0;

		do{
			try{
				System.out.println ("Escolha a Opo Desejada: \n"
						+ "1 Para Pesquisar por Nome\n"
						+ "2 Para Pesquisar por CPF\n"
						+ "3 Para Excluir Cadastro");
				s = Integer.parseInt(in.nextLine());
				if (s<1 && s>2){
					System.out.println ("Parmetro de consulta incorreto");
				}
			}catch (InputMismatchException e){
				System.out.println("Tipo de consulta no correspondente s opes apresentadas");
				in.next();
			}
		}while (s<1 && s>3);

		switch (s){
		case 1:	
			rsPesquisa.searchByName();
			break;
		case 2:
			rsPesquisa.searchByCPF();
			break;
		case 3:
			rsPesquisa.delete();
			break;
		}
		in.close();
	}

	public static void tabelaPrice(){
		JDBCTabelaPriceDAO price = new JDBCTabelaPriceDAO();
		Scanner in = new Scanner (System.in);
		int s=0;

		do{
			try{
				System.out.println ("Escolha o Parmetro da Consulta: \n"
						+ "1 Para Simular Tabela - Modelo Price\n"
						+ "2 Para Calcular Saldo Devedor");
				s = Integer.parseInt(in.nextLine());
				if (s!=1 && s!=2){
					System.out.println ("Parmetro de consulta incorreto");
				}
			}catch (InputMismatchException e){
				System.out.println("Tipo de consulta no correspondente s opes apresentadas");
				in.next();
			}
		}while (s!=1 && s!=2);
		switch (s){
		case 1:
			price.calcularTabela();
			break;
		case 2:
			price.saldoDevedor();
			break;
		}
		in.close();
	}

	public static void tabelaSac() {
		JDBCTabelaSACDAO sac = new JDBCTabelaSACDAO ();
		Scanner in = new Scanner (System.in);
		int s = 0;

		do{
			try{
				System.out.println ("Escolha uma opo"
						+ "\n1 - Simular Tabela - Modelo SAC"
						+ "\n2 - Consultar Saldo Devedor"
						+ "\n3 - Consultar Parcela");
				s = Integer.parseInt(in.nextLine());
			} catch (InputMismatchException e){
				System.out.println ("Tipo de dado no corresponde ao solicitado.");
			}
		}while (s<1 || s > 3);
		switch (s){
		case 1:
			sac.calcularTabela();
			break;
		case 2:
			sac.SaldoDevedor();
			break;
		case 3:
			sac.calcularParcela();
			break;
		}
		in.close();
	}
}
