package org.util.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.InputMismatchException;
import java.util.Scanner;

import org.util.Principal.Principal;
import org.util.cliente.Cliente;
import org.util.cliente.DadosFinanceiros;
import org.util.cliente.Financiamento;
import org.util.conexoJDBC.ConnectionFactory;

public class JDBCCadastroDAO implements CadastroDAO {

	private Connection connection;
	private int s = 0;
	private String sql; 
	private String termoPesquisa;
	private String resultado;
	Scanner insert = new Scanner (System.in);
	Cliente cliente = new Cliente ();
	DadosFinanceiros dfinan = new DadosFinanceiros();
	Financiamento finan = new Financiamento();

	public JDBCCadastroDAO(){
		System.out.println ("Efetuando Conexo com Banco de Dados");
		this.connection = ConnectionFactory.getConnection();
	}

	@Override
	public void insert () {
		Connection connection = null;
		PreparedStatement psSelect = null;
		ResultSet rsSelect = null;
		PreparedStatement psInsert = null;
		do{

			try {
				System.out.println ("Informe o CPF do cliente: ");
				cliente.setCpf(insert.nextLine());
				System.out.println ("Informe o Nome do cliente: ");
				cliente.setNome(insert.nextLine());
				do {
					try {
						System.out.println ("Informe a Categoria do Financiamento: \n" 
								+ "1 - Servidor Pblico\n" + "2 - Aposentado\n" + "3 - Pensionista");
						s = Integer.parseInt(insert.nextLine());
						if (s<1 || s>3 ){
							System.out.println("Categoria no cadastrada.");
						}
					}catch (InputMismatchException e){
						System.out.println("Valor no correspondente s opes apresentadas");
						insert.next();
					}
				}while (s<1 || s>3);

				if (s == 1){
					cliente.setCategoria("Servidor Pblico");
				} else if (s == 2) {
					cliente.setCategoria("Aposentado");
				} else {
					cliente.setCategoria("Pensionista");
				}
				s = 0;

				connection = this.connection;
				sql = "INSERT INTO Cliente " + "(nome, cpf, categoria) " + "VALUES (?,?,?)";
				psInsert = connection.prepareStatement (sql);
				psInsert.setString (1, cliente.getNome());
				psInsert.setString (2, cliente.getCpf());
				psInsert.setString (3, cliente.getCategoria());

				psInsert.executeUpdate();
			} catch (SQLException e){
				System.out.println ("Erro na insero de dados - Classe JDBCClienteDAO");
				System.out.println ("Descrio: " + e.getMessage());

			}

			String sql = "INSERT INTO DadosFinanceiros " + "(salarioLiquido, margemConsignavel, financiamentos, restanteMargemConsignavel) " 
					+ "VALUES (?,?,?,?)";


			try {
				System.out.println ("Informe o Valor do Salrio Lquido: ");
				dfinan.setSalarioLiquido(Double.parseDouble(insert.nextLine()));
				System.out.println ("Valor de Outros Financiamentos J Existentes: ");
				dfinan.setFinanciamentos(Double.parseDouble(insert.nextLine()));
				dfinan.setMargemConsignavel(dfinan.getSalarioLiquido()* 0.30);
				dfinan.setRestanteMargemConsignavel(dfinan.getMargemConsignavel() - dfinan.getFinanciamentos());

				connection = this.connection;
				psInsert = connection.prepareStatement (sql);
				psInsert.setDouble (1, dfinan.getSalarioLiquido());
				psInsert.setDouble (2, dfinan.getMargemConsignavel());
				psInsert.setDouble (3, dfinan.getFinanciamentos());
				psInsert.setDouble (4, dfinan.getRestanteMargemConsignavel());

				psInsert.executeUpdate();
			} catch (SQLException e){
				System.out.println ("Erro na insero de dados - Classe JDBCClienteDAO");
				System.out.println ("Descrio: " + e.getMessage());

			}

			sql = "INSERT INTO Financiamento " + "(valorFinanciar, parcelas, taxaJuros) " + "VALUES (?, ?, ?)";

			try {
				System.out.println ("Informe o Valor a ser Financiado: ");
				finan.setValorFinanciar(Double.parseDouble(insert.nextLine()));
				System.out.println ("Valor o Numero de Parcelas do Financiamento: ");
				finan.setParcelas(Integer.parseInt(insert.nextLine()));

				connection = this.connection;
				psInsert = connection.prepareStatement (sql);
				psInsert.setDouble (1, finan.getValorFinanciar());
				psInsert.setDouble (2, finan.getParcelas());
				psInsert.setDouble (3, 0);


				psInsert.executeUpdate();

			} catch (SQLException e){
				System.out.println ("Erro na insero de dados - Classe JDBCClienteDAO");
				System.out.println ("Descrio: " + e.getMessage());
			} 

			sql = "SELECT COUNT(*) FROM Cliente";
			try {
				connection = this.connection;
				psSelect = connection.prepareStatement (sql);
				rsSelect = psSelect.executeQuery();
				while (rsSelect.next()){
					s = rsSelect.getInt("count");
				}
				sql = "INSERT INTO Pesquisa " + "(idCliente, idDadosFinanceiros, idFinanciamento) "
						+ "VALUES (?, ?, ?)";

				psInsert = connection.prepareStatement (sql);
				psInsert.setLong (1, s);
				psInsert.setLong (2, s);
				psInsert.setLong (3, s);
				psInsert.executeUpdate();

			} catch (SQLException e) {
				System.out.println("Erro no mtodo findByAll da classe JDBCPesquisaDadosDAO.");
				System.out.println("Descrio do erro: " + e.getMessage());			
			} finally {
				ConnectionFactory.fecharConexo (connection, psInsert, rsSelect);
			}
			System.out.println ("Cadastro realizado com sucesso!");

			do{
				try{
					System.out.println ("Deseja realizar outro cadastro?");
					s = Integer.parseInt(insert.nextLine());
					if (s!=1 && s!=2){
						System.out.println ("Opo no disponvel");
					}
				}catch (Exception e){
					System.out.println ("Opo no suportada pelo sistema.");
					insert.next();
				}
			}while (s!= 1 && s!=2);
		} while (s!= 2);
		Principal.main(null);
	}

	@Override
	public void update() {
		// TODO Auto-generated method stub

		do {
			try{
				System.out.println ("Selecione o Mtodo de Consulta"
						+ "\n1 - Nome | 2 - CPF");
				s = Integer.parseInt(insert.nextLine());
				if (s != 1 && s != 2){
					System.out.println ("Tipo de pesquisa invlido. ");
				}
			} catch (InputMismatchException e){
				System.out.println ("Tipo de dado no suportado.");
				insert.next();
			}
		}while (s != 1 && s != 2);
		if (s == 1){
			System.out.println ("Informe o nome do cliente.");
			termoPesquisa = insert.nextLine();
			sql = "SELECT cliente.id, nome, cpf, categoria, salarioLiquido, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
					+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
					+ "WHERE nome ILIKE '%" + termoPesquisa + "%'\n"
					+ "AND Pesquisa.idCliente = Cliente.id\n"
					+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
					+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
		} else {
			System.out.println ("Informe o CPF do cliente.");
			termoPesquisa = insert.nextLine();
			sql = "SELECT cliente.id, nome, cpf, categoria, salarioLiquido, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
					+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
					+ "WHERE cpf ILIKE '%" + termoPesquisa + "%'\n"
					+ "AND Pesquisa.idCliente = Cliente.id\n"
					+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
					+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
		}
		s = 0;
		Connection connection = null;
		PreparedStatement psSelect = null;
		PreparedStatement psInsert = null;
		psInsert = null;
		ResultSet rsSelect = null;

		try{
			connection = this.connection;
			psSelect = connection.prepareStatement(sql);
			rsSelect = psSelect.executeQuery();
			while (rsSelect.next()){
				cliente.setId(rsSelect.getLong("id"));
				cliente.setNome(rsSelect.getString("nome"));
				cliente.setCpf(rsSelect.getString("cpf"));
				cliente.setCategoria(rsSelect.getString("categoria"));
				dfinan.setSalarioLiquido(rsSelect.getDouble("salarioLiquido"));
				dfinan.setRestanteMargemConsignavel(rsSelect.getDouble("restanteMargemConsignavel"));
				finan.setValorFinanciar(rsSelect.getDouble("valorFinanciar"));
				finan.setParcelas(rsSelect.getInt("parcelas"));

				resultado = "Resultado(s) da Pesquisa:\n"+
						"Cdigo do Cliente: " + cliente.getId() 
						+ "\nNome: " + cliente.getNome() + " C.P.F.: " + cliente.getCpf() + " Categoria: " + cliente.getCategoria()
						+ "\nSalrio Lquido: " + dfinan.getSalarioLiquido() + " Margem Consignvel Disponvel: " + dfinan.getRestanteMargemConsignavel()
						+ "\nValor Solicitado: " + finan.getValorFinanciar() + " Nmero de Parcelas Contratado: " + finan.getParcelas()
						+ "\n|===================================================================|";

				System.out.println (resultado);
			}
		} catch (SQLException e){
			System.out.println("Erro no mtodo findByAll da classe JDBCPesquisaDadosDAO.");
			System.out.println("Descrio do erro: " + e.getMessage());
		} finally {
			ConnectionFactory.fecharConexo(connection, psSelect);
		}

		s = 0;
		do {
			do {
				try{
					System.out.println ("Informe quais dados deseja alterar"
							+ "\n1 - Dados Cadastrais | 2 - Dados Financeiros | 3 - Dados do Financiamento");
					s = Integer.parseInt(insert.nextLine());
					if (s <1 && s > 3){
						System.out.println ("Tipo de pesquisa invlido. ");
					}
				} catch (InputMismatchException e){
					System.out.println ("Tipo de dado no suportado.");
					insert.next();
				}
			}while (s <1 && s > 3);
			switch (s){
			case 1:
				try {

					System.out.println ("Informe o CPF do cliente: ");
					cliente.setCpf(insert.nextLine());
					System.out.println ("Informe o Nome do cliente: ");
					cliente.setNome(insert.nextLine());
					do {
						try {
							System.out.println ("Informe a Categoria do Financiamento: \n" 
									+ "1 - Servidor Pblico\n" + "2 - Aposentado\n" + "3 - Pensionista");
							s = Integer.parseInt(insert.nextLine());
							if (s<1 || s>3 ){
								System.out.println("Categoria no cadastrada.");
							}
						}catch (InputMismatchException e){
							System.out.println("Valor no correspondente s opes apresentadas");
							insert.next();
						}
					}while (s<1 || s>3);

					if (s == 1){
						cliente.setCategoria("Servidor Pblico");
					} else if (s == 2) {
						cliente.setCategoria("Aposentado");
					} else {
						cliente.setCategoria("Pensionista");
					}
					s = 0;

					connection = this.connection;
					sql = "UPDATE Cliente " + "SET nome = ?" + " Where id = " + cliente.getId() + ";";
					psInsert = connection.prepareStatement (sql);
					psInsert.setString (1, cliente.getNome());
					sql = "UPDATE Cliente " + "SET cpf = ?" + " Where id = " + cliente.getId() + ";";
					psInsert = connection.prepareStatement (sql);
					psInsert.setString (1, cliente.getCpf());
					sql = "UPDATE Cliente " + "SET categoria = ?" + " Where id = " + cliente.getId() + ";";
					psInsert = connection.prepareStatement (sql);
					psInsert.setString (1, cliente.getCategoria());
					psInsert.executeUpdate();
				} catch (Exception e){
					System.out.println ("Erro encontrado: " + e.getMessage());
				} finally {
					ConnectionFactory.fecharConexo(connection, psInsert);
				}
				break;
			case 2:
				try {
					System.out.println ("Informe o Valor do Salrio Lquido: ");
					dfinan.setSalarioLiquido(Double.parseDouble(insert.nextLine()));
					System.out.println ("Valor de Outros Financiamentos J Existentes: ");
					dfinan.setFinanciamentos(Double.parseDouble(insert.nextLine()));
					dfinan.setMargemConsignavel(dfinan.getSalarioLiquido()* 0.30);
					dfinan.setRestanteMargemConsignavel(dfinan.getMargemConsignavel() - dfinan.getFinanciamentos());

					connection = this.connection;
					sql = "UPDATE DadosFinanceiros " + "SET salarioLiquido = ?" + " Where id = " + cliente.getId() + ";";
					psInsert = connection.prepareStatement (sql);
					psInsert.setDouble (1, dfinan.getSalarioLiquido());
					sql = "UPDATE DadosFinanceiros " + "SET margemConsignavel = ?" + " Where id = " + cliente.getId() + ";";
					psInsert = connection.prepareStatement (sql);
					psInsert.setDouble (1, dfinan.getMargemConsignavel());
					sql = "UPDATE DadosFinanceiros " + "SET financiamentos = ?" + " Where id = " + cliente.getId() + ";";
					psInsert = connection.prepareStatement (sql);
					psInsert.setDouble (1, dfinan.getFinanciamentos());
					sql = "UPDATE DadosFinanceiros " + "SET restanteMargemConsignavel = ?" + " Where id = " + cliente.getId() + ";";
					psInsert = connection.prepareStatement (sql);
					psInsert.setDouble (1, dfinan.getRestanteMargemConsignavel());
					psInsert.executeUpdate();
				} catch (SQLException e){
					System.out.println ("Erro na insero de dados - Classe JDBCClienteDAO");
					System.out.println ("Descrio: " + e.getMessage());
				} finally {
					ConnectionFactory.fecharConexo(connection, psInsert);
				}
				break;
			case 3:
				try {
					System.out.println ("Informe o Valor a ser Financiado: ");
					finan.setValorFinanciar(Double.parseDouble(insert.nextLine()));
					System.out.println ("Valor o Numero de Parcelas do Financiamento: ");
					finan.setParcelas(Integer.parseInt(insert.nextLine()));

					connection = this.connection;
					sql = "UPDATE Financiamento " + "SET valorFinanciar = ?" + " Where id = " + cliente.getId() + ";";
					psInsert = connection.prepareStatement (sql);
					psInsert.setDouble (1, finan.getValorFinanciar());
					sql = "UPDATE Financiamento " + "SET parcelas = ?" + " Where id = " + cliente.getId() + ";";
					psInsert = connection.prepareStatement (sql);
					psInsert.setDouble (1, finan.getParcelas());
					sql = "UPDATE Financiamento " + "SET taxaJuros = ?" + " Where id = " + cliente.getId() + ";";
					psInsert = connection.prepareStatement (sql);
					psInsert.setDouble (1, 0);
					psInsert.executeUpdate();

				} catch (SQLException e){
					System.out.println ("Erro na insero de dados - Classe JDBCClienteDAO");
					System.out.println ("Descrio: " + e.getMessage());
				} finally {
					ConnectionFactory.fecharConexo(connection, psInsert);
				} 
				break;
			}
			s = 0;
			do {
				try{
					System.out.println ("Deseja alterar mais algum dado para o cliente " + cliente.getNome() + "?"
							+ "1 - Sim | 2 - No");
					s = Integer.parseInt(insert.nextLine());
					if (s != 1 && s != 2){
						System.out.println ("Tipo de pesquisa invlido. ");
					}
				} catch (InputMismatchException e){
					System.out.println ("Tipo de dado no suportado.");
					insert.next();
				}
			}while (s != 1 && s != 2);

		} while (s !=2);
		System.out.println ("Dados alterados com sucesso.");
		Principal.main(null);
	}
}
