package org.util.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.InputMismatchException;
import java.util.Scanner;

import org.util.Principal.Principal;
import org.util.cliente.DadosFinanceiros;
import org.util.cliente.Financiamento;
import org.util.cliente.Cliente;
import org.util.conexoJDBC.ConnectionFactory;

public class JDBCPesquisaDadosDAO implements PesquisaDadosDAO {

	private Connection connection;
	private String sql;
	private String termoPesquisa;
	private String resultado;
	private int s = 0;
	private int id = 0;

	private Scanner in = new Scanner(System.in);

	Cliente cliente = new Cliente ();
	DadosFinanceiros dfinan = new DadosFinanceiros();
	Financiamento finan = new Financiamento();

	public JDBCPesquisaDadosDAO (){
		this.connection = ConnectionFactory.getConnection();
	}


	@Override
	public void searchByCPF() {
		do{
			System.out.println ("Informe o CPF do Cliente: ");
			termoPesquisa = in.nextLine();

			sql = "SELECT cliente.id, nome, cpf, categoria, salarioLiquido, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
					+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
					+ "WHERE cpf ILIKE '" + termoPesquisa + "%'\n"
					+ "AND Pesquisa.idCliente = Cliente.id\n"
					+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
					+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
			Connection connection = null;
			PreparedStatement psSelect = null;
			ResultSet rsSelect = null;

			try{
				connection = this.connection;
				psSelect = connection.prepareStatement(sql);
				rsSelect = psSelect.executeQuery();
				while (rsSelect.next()){
					Cliente cliente = new Cliente ();
					DadosFinanceiros dados = new DadosFinanceiros ();
					Financiamento financiamento = new Financiamento();
					cliente.setId(rsSelect.getLong("id"));
					cliente.setNome(rsSelect.getString("nome"));
					cliente.setCpf(rsSelect.getString("cpf"));
					cliente.setCategoria(rsSelect.getString("categoria"));
					dados.setSalarioLiquido(rsSelect.getDouble("salarioLiquido"));
					dados.setRestanteMargemConsignavel(rsSelect.getDouble("restanteMargemConsignavel"));
					financiamento.setValorFinanciar(rsSelect.getDouble("valorFinanciar"));
					financiamento.setParcelas(rsSelect.getInt("parcelas"));

					resultado = "Resultado(s) da Pesquisa:\n"+
							"Cdigo do Cliente: " + cliente.getId() 
							+ "\nNome: " + cliente.getNome() + " C.P.F.: " + cliente.getCpf() + " Categoria: " + cliente.getCategoria()
							+ "\nSalrio Lquido: " + dados.getSalarioLiquido() + " Margem Consignvel Disponvel: " + dados.getRestanteMargemConsignavel()
							+ "\nValor Solicitado: " + financiamento.getValorFinanciar() + " Nmero de Parcelas Contratado: " + financiamento.getParcelas()
							+ "\n|===================================================================|";

					System.out.println (resultado);
				}

			} catch (SQLException e){
				System.out.println("Erro no mtodo findByAll da classe JDBCPesquisaDadosDAO.");
				System.out.println("Descrio do erro: " + e.getMessage());
			} finally {
				ConnectionFactory.fecharConexo(connection, psSelect);
			}
			do{
				try{
					System.out.println ("Deseja realizar outra consulta?");
					s = Integer.parseInt(in.nextLine());
					if (s!=1 && s!=2){
						System.out.println ("Opo no disponvel");
					}
				}catch (Exception e){
					System.out.println ("Opo no suportada pelo sistema.");
					in.next();
				}
			}while (s!= 1 && s!=2);
		} while (s!= 2);
		Principal.main(null);
		termoPesquisa = null;
	}

	@Override
	public void searchByName() {
		// TODO Auto-generated method stub
		do{
			System.out.println ("Informe o Nome do Cliente: ");
			termoPesquisa = in.nextLine();

			sql = "SELECT cliente.id, nome, cpf, categoria, salarioLiquido, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
					+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
					+ "WHERE nome ILIKE '" + termoPesquisa + "%'\n"
					+ "AND Pesquisa.idCliente = Cliente.id\n"
					+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
					+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
			Connection connection = null;
			PreparedStatement psSelect = null;
			ResultSet rsSelect = null;

			try{
				connection = this.connection;
				psSelect = connection.prepareStatement(sql);
				rsSelect = psSelect.executeQuery();
				while (rsSelect.next()){
					Cliente cliente = new Cliente ();
					DadosFinanceiros dados = new DadosFinanceiros ();
					Financiamento financiamento = new Financiamento();
					cliente.setId(rsSelect.getLong("id"));
					cliente.setNome(rsSelect.getString("nome"));
					cliente.setCpf(rsSelect.getString("cpf"));
					cliente.setCategoria(rsSelect.getString("categoria"));
					dados.setSalarioLiquido(rsSelect.getDouble("salarioLiquido"));
					dados.setRestanteMargemConsignavel(rsSelect.getDouble("restanteMargemConsignavel"));
					financiamento.setValorFinanciar(rsSelect.getDouble("valorFinanciar"));
					financiamento.setParcelas(rsSelect.getInt("parcelas"));

					resultado = "Resultado(s) da Pesquisa:\n"+
							"Cdigo do Cliente - " + cliente.getId() 
							+ "\nNome: " + cliente.getNome() + " C.P.F.: " + cliente.getCpf() + " Categoria: " + cliente.getCategoria()
							+ "\nSalrio Lquido: " + dados.getSalarioLiquido() + " Margem Consignvel Disponvel: " + dados.getRestanteMargemConsignavel()
							+ "\nValor Solicitado: " + financiamento.getValorFinanciar() + " Nmero de Parcelas: " + financiamento.getParcelas()
							+ "\n|===================================================================|";

					System.out.println (resultado);
				}

			} catch (SQLException e){
				System.out.println("Erro no mtodo findByAll da classe JDBCPesquisaDadosDAO.");
				System.out.println("Descrio do erro: " + e.getMessage());
			} finally {
				ConnectionFactory.fecharConexo(connection, psSelect);
			}
			do{
				try{
					System.out.println ("Deseja realizar outra consulta?");
					s = Integer.parseInt(in.nextLine());
					if (s!=1 && s!=2){
						System.out.println ("Opo no disponvel");
					}
				}catch (Exception e){
					System.out.println ("Opo no suportada pelo sistema.");
					in.next();
				}
			}while (s!= 1 && s!=2);
		} while (s!= 2);
		Principal.main(null);
		termoPesquisa = null;
	}

	@Override
	public void delete() {
		// TODO Auto-generated method stub
		Connection connection = null;
		PreparedStatement psSelect = null;
		PreparedStatement psInsert = null;
		psInsert = null;
		ResultSet rsSelect = null;

		do{
			try {
				do {
					try{
						System.out.println ("Selecione o Mtodo de Consulta"
								+ "\n1 - Nome | 2 - CPF");
						s = Integer.parseInt(in.nextLine());
						if (s != 1 && s != 2){
							System.out.println ("Tipo de pesquisa invlido. ");
						}
					} catch (InputMismatchException e){
						System.out.println ("Tipo de dado no suportado.");
						in.next();
					}
				}while (s != 1 && s != 2);
				if (s == 1){
					System.out.println ("Informe o nome do cliente.");
					termoPesquisa = in.nextLine();
					sql = "SELECT cliente.id, nome, cpf, categoria, salarioLiquido, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
							+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
							+ "WHERE nome ILIKE '%" + termoPesquisa + "%'\n"
							+ "AND Pesquisa.idCliente = Cliente.id\n"
							+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
							+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
				} else {
					System.out.println ("Informe o CPF do cliente.");
					termoPesquisa = in.nextLine();
					sql = "SELECT cliente.id, nome, cpf, categoria, salarioLiquido, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
							+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
							+ "WHERE cpf ILIKE '%" + termoPesquisa + "%'\n"
							+ "AND Pesquisa.idCliente = Cliente.id\n"
							+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
							+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
				}
				s = 0;


				try{
					connection = this.connection;
					psSelect = connection.prepareStatement(sql);
					rsSelect = psSelect.executeQuery();
					while (rsSelect.next()){
						cliente.setId(rsSelect.getLong("id"));
						cliente.setNome(rsSelect.getString("nome"));
						cliente.setCpf(rsSelect.getString("cpf"));
						cliente.setCategoria(rsSelect.getString("categoria"));
						dfinan.setSalarioLiquido(rsSelect.getDouble("salarioLiquido"));
						dfinan.setRestanteMargemConsignavel(rsSelect.getDouble("restanteMargemConsignavel"));
						finan.setValorFinanciar(rsSelect.getDouble("valorFinanciar"));
						finan.setParcelas(rsSelect.getInt("parcelas"));
					}
				} catch (SQLException e){
					System.out.println("Erro no mtodo findByAll da classe JDBCPesquisaDadosDAO.");
					System.out.println("Descrio do erro: " + e.getMessage());
				} finally {
					ConnectionFactory.fecharConexo(connection, psSelect);
				}

				resultado = "Resultado(s) da Pesquisa:\n"+
						"Cdigo do Cliente: " + cliente.getId() 
						+ "\nNome: " + cliente.getNome() + " C.P.F.: " + cliente.getCpf() + " Categoria: " + cliente.getCategoria()
						+ "\nSalrio Lquido: " + dfinan.getSalarioLiquido() + " Margem Consignvel Disponvel: " + dfinan.getRestanteMargemConsignavel()
						+ "\nValor Solicitado: " + finan.getValorFinanciar() + " Nmero de Parcelas Contratado: " + finan.getParcelas()
						+ "\n|===================================================================|";
				System.out.println (resultado);

				do{
					try{
						System.out.println ("Esta operao no poder ser desfeita. Continuar?"
								+ "\n1 - Sim ou 2 - No");
						s = Integer.parseInt(in.nextLine());
						if (s!=1 && s!=2){
							System.out.println ("Parmetro de consulta incorreto");
						}
					}catch (InputMismatchException e){
						System.out.println("Tipo de consulta no correspondente s opes apresentadas");
						in.next();
					}
				}while (s!=1 && s!=2);

				if (s==1){

					connection = this.connection;
					sql = "DELETE FROM Pesquisa WHERE Pesquisa.idCliente = ?";
					psInsert = connection.prepareStatement(sql);
					psInsert.setLong (1, cliente.getId());
					psInsert.executeUpdate();

					sql = "DELETE FROM Financiamento WHERE Financiamento.id = ?";
					psInsert = connection.prepareStatement(sql);
					psInsert.setLong (1, cliente.getId());
					psInsert.executeUpdate();

					sql = "DELETE FROM DadosFinanceiros WHERE DadosFinanceiros.id = ?";
					psInsert = connection.prepareStatement(sql);
					psInsert.setLong (1, cliente.getId());
					psInsert.executeUpdate();

					sql = "DELETE FROM Cliente WHERE Cliente.id = ?";
					psInsert = connection.prepareStatement(sql);
					psInsert.setLong (1, cliente.getId());
					psInsert.executeUpdate();

					sql = "SELECT COUNT(*) FROM Pesquisa";
					psSelect = connection.prepareStatement(sql);
					rsSelect = psSelect.executeQuery();
					while (rsSelect.next()){
						s = rsSelect.getInt("count");
					}

					if (cliente.getId() != s){
						sql = "UPDATE Pesquisa SET idCliente = ?, idDadosFinanceiros = ?, idFinanciamento = ? Where idCliente = ?";
						psInsert = connection.prepareStatement (sql);
						psInsert.setLong (1, cliente.getId());
						psInsert.setLong (2, s);
						psInsert.setLong (3, s);
						psInsert.setLong (4, cliente.getId());
						psInsert.executeUpdate();
					}	


				}

				s = 0;
				do {
					try{
						System.out.println ("Deseja excluir outro registro?"
								+ "\n1 - Sim | 2 - No");
						s = Integer.parseInt(in.nextLine());
						if (s != 1 && s != 2){
							System.out.println ("Tipo de pesquisa invlido. ");
						}
					} catch (InputMismatchException e){
						System.out.println ("Tipo de dado no suportado.");
						in.next();
					}
				}while (s != 1 && s != 2);
			} catch (SQLException e){
				System.out.println("Erro no mtodo findByAll da classe JDBCPesquisaDadosDAO.");
				System.out.println("Descrio do erro: " + e.getMessage());
			} finally {
				ConnectionFactory.fecharConexo(connection, psSelect);
				System.out.println ("Registro excluido com sucesso");
			}
		} while (s!= 2);
		Principal.main(null);
	}
}