package org.util.dao;

import java.awt.Desktop;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.InputMismatchException;
import java.util.Locale;
import java.util.Scanner;

import javax.swing.JOptionPane;

import org.util.Principal.Principal;
import org.util.cliente.Cliente;
import org.util.cliente.Financiamento;
import org.util.cliente.TabelaPrice;
import org.util.conexoJDBC.ConnectionFactory;

import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Element;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.pdf.PdfPCell;
import com.itextpdf.text.pdf.PdfPTable;
import com.itextpdf.text.pdf.PdfWriter;

public class JDBCTabelaPriceDAO implements TabelaPriceDAO{

	private Connection connection;

	private int s = 0;
	private String sql = null;
	private String termoPesquisa = null;

	Scanner intabela = new Scanner (System.in);
	Locale local = Locale.getDefault();
	NumberFormat nForm = NumberFormat.getCurrencyInstance(local);
	DecimalFormat nPerc = new DecimalFormat ("#.00");

	Cliente cliente = new Cliente ();
	TabelaPrice price = new TabelaPrice();
	Financiamento finan = new Financiamento ();

	public JDBCTabelaPriceDAO(){
		this.connection = ConnectionFactory.getConnection();
	}



	@Override
	public void calcularTabela() {
		// TODO Auto-generated method stub
		do{
			do {
				try{
					System.out.println ("Selecione o Mtodo de Consulta"
							+ "\n1 - Nome | 2 - CPF");
					s = Integer.parseInt(intabela.nextLine());
					if (s != 1 && s != 2){
						System.out.println ("Tipo de pesquisa invlido. ");
					}
				} catch (InputMismatchException e){
					System.out.println ("Tipo de dado no suportado.");
					intabela.next();
				}
			}while (s != 1 && s != 2);
			if (s == 1){
				System.out.println ("Informe o nome do cliente.");
				termoPesquisa = intabela.nextLine();
				sql = "SELECT cliente.id, nome, cpf, categoria, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
						+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
						+ "WHERE nome ILIKE '%" + termoPesquisa + "%'\n"
						+ "AND Pesquisa.idCliente = Cliente.id\n"
						+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
						+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
			} else {
				System.out.println ("Informe o CPF do cliente.");
				termoPesquisa = intabela.nextLine();
				sql = "SELECT cliente.id, nome, cpf, categoria, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
						+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
						+ "WHERE cpf ILIKE '%" + termoPesquisa + "%'\n"
						+ "AND Pesquisa.idCliente = Cliente.id\n"
						+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
						+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
			}
			s = 0;

			Connection connection = null;
			PreparedStatement psSelect = null;
			PreparedStatement psInsert = null;
			ResultSet rsSelect = null;

			try {
				connection = this.connection;
				psSelect = connection.prepareStatement (sql);
				psInsert = connection.prepareStatement (sql);
				rsSelect = psSelect.executeQuery();

				while (rsSelect.next()){
					cliente.setId(rsSelect.getLong("id"));
					cliente.setNome(rsSelect.getString("nome"));
					cliente.setCpf(rsSelect.getString("cpf"));
					cliente.setCategoria(rsSelect.getString("categoria"));
					price.setSaldoDevedor(rsSelect.getDouble("valorFinanciar"));
					price.setParcela(rsSelect.getInt("parcelas"));
					price.setValorMaximoParcela(rsSelect.getDouble("restanteMargemConsignavel"));
					price.setCategoriaCliente(rsSelect.getString("categoria"));
				}
				do{
					try{
						System.out.println ("Taxa de juros a utilizar: "
								+ "1 - Personalizado | 2 - Por Categoria");
						s = Integer.parseInt(intabela.nextLine());
					}catch (InputMismatchException e){
						System.out.println ("Tipo de dado no corresponde  informao solicitada.");
					}
					if(s!=1 && s!=2){
						System.out.println ("Taxa de juros no compatvel para simulao.");
					}
				}while (s!=1 && s!=2);
				price.setJurosDevedor(-1);
				if (s == 1){
					do{
						try {
							System.out.println ("Taxa de juros: ");
							price.setJurosDevedor(intabela.nextDouble() / 100);
						} catch (InputMismatchException e){
							System.out.println ("Formato digitado no suportado.");
							intabela.next();
						}
						sql = "UPDATE Financiamento " + "SET taxaJuros = ?" + " Where id = " + cliente.getId();
						try {
							connection = this.connection;
							psInsert = connection.prepareStatement (sql);
							psInsert.setDouble (1, price.getJurosDevedor());
						} catch (SQLException e){
							System.out.println ("Erro na insero de dados - Classe JDBCClienteDAO");
							System.out.println ("Descrio: " + e.getMessage());
						}
						psInsert.executeUpdate();
					}while (price.getJurosDevedor() < 0);
				} else {
					if(price.getCategoriaCliente().equalsIgnoreCase("Servidor Pblico")){
						price.setJurosDevedor(1.80 / 100);
					} else if(price.getCategoriaCliente().equalsIgnoreCase("Pensionista")){
						price.setJurosDevedor(1.90 / 100);
					} else if(price.getCategoriaCliente().equalsIgnoreCase("Aposentado")){
						price.setJurosDevedor(1.70 / 100);
					}
					sql = "UPDATE Financiamento " + "SET taxaJuros = ?" + " Where id = " + cliente.getId();
					try {
						connection = this.connection;
						psInsert = connection.prepareStatement (sql);
						psInsert.setDouble (1, price.getJurosDevedor());
					} catch (SQLException e){
						System.out.println ("Erro na insero de dados - Classe JDBCClienteDAO");
						System.out.println ("Descrio: " + e.getMessage());
					}
				}
				s = 0;
				price.setValorParcela(price.getSaldoDevedor() * (((Math.pow(price.getJurosDevedor() + 1, price.getParcela())) * price.getJurosDevedor()) / ((Math.pow(price.getJurosDevedor() + 1, price.getParcela())) - 1)));
				try{
					if (price.getValorParcela() > price.getValorMaximoParcela()){
						System.out.println ("Valor da parcela, para o valor solicitado, excede o mximo permitido para o contrato."
								+ "\nDeseja alterar os dados?"
								+ "\n1 - Sim | 2 - No");
						s = Integer.parseInt(intabela.nextLine());
					}
				}catch (Exception e){
					System.out.println ("Tipo de informao no compatvel com o dado solicitado");
					intabela.next();
				}
				do{
					if (s == 1){
						try{
							System.out.println ("Valor a financiar: ");
							finan.setValorFinanciar(Double.parseDouble(intabela.nextLine()));
							sql = "UPDATE Financiamento " + "SET valorFinanciar = ?" + " Where id = " + cliente.getId();
							try {
								connection = this.connection;
								psInsert = connection.prepareStatement (sql);
								psInsert.setDouble (1, finan.getValorFinanciar());
							} catch (SQLException e){
								System.out.println ("Erro na insero de dados - Classe JDBCTabelaSACDAO");
								System.out.println ("Descrio: " + e.getMessage());
							}
							psInsert.executeUpdate();
							price.setSaldoDevedor(finan.getValorFinanciar());

							System.out.println ("Nmero de parcelas: ");
							finan.setParcelas(Integer.parseInt(intabela.nextLine()));
							sql = "UPDATE Financiamento " + "SET parcelas = ?" + " Where id = " + cliente.getId();
							try {
								connection = this.connection;
								psInsert = connection.prepareStatement (sql);
								psInsert.setInt (1, price.getParcela());
							} catch (SQLException e){
								System.out.println ("Erro na insero de dados - Classe JDBCTabelaPriceDAO");
								System.out.println ("Descrio: " + e.getMessage());
							}
							psInsert.executeUpdate();
							price.setParcela(finan.getParcelas());

						}catch (Exception e){
							System.out.println ("Erro na Insero dos dados.");
						}
						price.setValorParcela(price.getSaldoDevedor() * (((Math.pow(price.getJurosDevedor() + 1, price.getParcela())) * price.getJurosDevedor()) / ((Math.pow(price.getJurosDevedor() + 1, price.getParcela())) - 1)));
						try{
							if (price.getValorParcela() > price.getValorMaximoParcela()){
								System.out.println ("Valor da parcela, para o valor solicitado, excede o mximo permitido para o contrato."
										+ "\nDeseja alterar os dados?"
										+ "\n1 - Sim | 2 - No");
								s = Integer.parseInt(intabela.nextLine());
							}
						}catch (Exception e){
							System.out.println ("Tipo de informao no compatvel com o dado solicitado");
							intabela.next();
						}
					}

				} while (s!=2);
				s = 0;
				if (price.getValorParcela() < price.getValorMaximoParcela()){
					try{
						PdfPTable table = new PdfPTable(6);
						Document docprice = new Document (PageSize.A4);
						PdfWriter.getInstance(docprice, new FileOutputStream("Tabela Price.pdf"));
						docprice.open();
						System.out.println ("Gerando simulao - Modelo Price");

						PdfPCell header = new PdfPCell(new Paragraph ("Simulao - Tabela Price" + "\nCliente: " + cliente.getNome()
								+ "\nC.P.F.: " + cliente.getCpf() + " | Categoria: " + cliente.getCategoria()
								+ "\n========================================================="
								+ "\nTaxa de Juros: " + nPerc.format((price.getJurosDevedor() * 100)) + "% | Prazo: " + price.getParcela() + " meses."));
						header.setHorizontalAlignment(Element.ALIGN_CENTER);
						header.setColspan(6);
						table.addCell(header);

						table.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell("Prestao");
						table.addCell("Valor Contratado");
						table.addCell("Valor da Parcela");
						table.addCell("Amort.");
						table.addCell("Valor dos Juros");
						table.addCell("Saldo Devedor");

						for (int i = 1; i<=price.getParcela(); i++){
							price.setValorJuro(price.getSaldoDevedor() * price.getJurosDevedor());
							price.setAmortizacao(price.getValorParcela() - price.getValorJuro());

							table.addCell(String.valueOf(i));
							table.addCell(String.valueOf(nForm.format(price.getSaldoDevedor())));
							table.addCell(String.valueOf(nForm.format(price.getValorParcela())));
							table.addCell(String.valueOf(nForm.format(price.getAmortizacao())));
							table.addCell(String.valueOf(nForm.format(price.getValorJuro())));
							table.addCell(String.valueOf(nForm.format(price.getSaldoPosterior())));

							price.setSaldoDevedor(price.getSaldoDevedor() - price.getAmortizacao());
						}

						docprice.add(table);
						docprice.close();
						s = 0;
						do {
							try{
								System.out.println ("Simulao gerada com sucesso. Deseja abrir simulao?"
										+ "\n1 - Sim | 2 - No");
								s = Integer.parseInt(intabela.nextLine());
								if (s!= 1 && s!= 2){
									System.out.println ("Opo no disponvel");
								}
							} catch (Exception e){
								System.out.println ("Tipo de opo no suportado");
								intabela.next();
							}
						}while (s!= 1 && s!= 2);
						if (s == 1) {
							try{
								File pdf = new File ("Tabela Price.pdf");
								Desktop.getDesktop().open(pdf);
							} catch (Exception ex){
								ex.printStackTrace();
								JOptionPane.showMessageDialog(null, "Erro no Desktop" + ex);
							}
						}

					}catch (DocumentException de) {
						System.err.println(de.getMessage());
					} 
					catch (IOException ioe) {
						System.err.println(ioe.getMessage());
					}
				}
			} catch (SQLException e){
				System.out.println ("Erro na manipulao de dados - Classe JDBCTabelaPriceDAO");
				System.out.println ("Descrio: " + e.getMessage());
			} finally{
				ConnectionFactory.fecharConexo(null, null);
			}
			s = 0;
			do{
				try{
					System.out.println ("Deseja realizar outra simulao?"
							+ "\n1 - Sim | 2 - No");
					s = Integer.parseInt(intabela.nextLine());
					if (s!=1 && s!=2){
						System.out.println ("Opo no disponvel");
					}
				}catch (Exception e){
					System.out.println ("Opo no suportada pelo sistema.");
					intabela.next();
				}
			}while (s!= 1 && s!=2);
		} while (s!= 2);
		Principal.main(null);
	}

	@Override
	public void saldoDevedor() {
		// TODO Auto-generated method stub
		do{
			do {
				try{
					System.out.println ("Selecione o Mtodo de Consulta"
							+ "\n1 - Nome | 2 - CPF");
					s = Integer.parseInt(intabela.nextLine());
					if (s != 1 && s != 2){
						System.out.println ("Tipo de pesquisa invlido. ");
					}
				} catch (InputMismatchException e){
					System.out.println ("Tipo de dado no suportado.");
				}
			}while (s != 1 && s != 2);
			if (s == 1){
				System.out.println ("Informe o nome do cliente.");
				termoPesquisa = intabela.nextLine();
				sql = "SELECT nome, cpf, categoria, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
						+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
						+ "WHERE nome ILIKE '%" + termoPesquisa + "%'\n"
						+ "AND Pesquisa.idCliente = Cliente.id\n"
						+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
						+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
			} else {
				System.out.println ("Informe o CPF do cliente.");
				termoPesquisa = intabela.nextLine();
				sql = "SELECT nome, cpf, categoria, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
						+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
						+ "WHERE cpf ILIKE '%" + termoPesquisa + "%'\n"
						+ "AND Pesquisa.idCliente = Cliente.id\n"
						+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
						+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
			}

			Connection connection = null;
			PreparedStatement psSelect = null;
			ResultSet rsSelect = null;

			try {
				connection = this.connection;
				psSelect = connection.prepareStatement (sql);
				rsSelect = psSelect.executeQuery();

				while (rsSelect.next()){
					cliente.setNome(rsSelect.getString("nome"));
					cliente.setCpf(rsSelect.getString("cpf"));
					cliente.setCategoria(rsSelect.getString("categoria"));
					price.setSaldoDevedor(rsSelect.getDouble("valorFinanciar"));
					price.setTotalParcelas(rsSelect.getInt("parcelas"));
					price.setValorMaximoParcela(rsSelect.getDouble("restanteMargemConsignavel"));
					price.setCategoriaCliente(rsSelect.getString("categoria"));
				}

				System.out.println ("Informe o nmero de parcelas pagas: ");
				price.setParcela(intabela.nextInt());

				if(price.getCategoriaCliente().equalsIgnoreCase("Ativo")){
					price.setJurosDevedor(1.80 / 100);
				} else if(price.getCategoriaCliente().equalsIgnoreCase("Pensionista")){
					price.setJurosDevedor(1.90 / 100);
				} else if(price.getCategoriaCliente().equalsIgnoreCase("Aposentado")){
					price.setJurosDevedor(1.70 / 100);
				}

				price.setValorParcela(price.getSaldoDevedor() * (((Math.pow(price.getJurosDevedor() + 1, price.getTotalParcelas())) * price.getJurosDevedor()) / ((Math.pow(price.getJurosDevedor() + 1, price.getTotalParcelas())) - 1)));

				System.out.println ("Cliente: " + cliente.getNome()
						+ "\nC.P.F.: " + cliente.getCpf() + " | Categoria: " + cliente.getCategoria()
						+ "\n----------------------------------------------------------------------------");
				for (int i = 1; i<=price.getParcela(); i++){
					price.setValorJuro(price.getSaldoDevedor() * price.getJurosDevedor());
					price.setAmortizacao(price.getValorParcela() - price.getValorJuro());
					price.setSaldoDevedor(price.getSaldoDevedor() - price.getAmortizacao());
				}
				System.out.println ("Saldo Devedor aps " + price.getParcela() + " meses: " + nForm.format(price.getSaldoDevedor())
						+ "\n----------------------------------------------------------------------------");
			} catch (SQLException e){
				System.out.println ("Erro na manipulao de dados - Classe JDBCTabelaPriceDAO");
				System.out.println ("Descrio: " + e.getMessage());
			} finally{
				ConnectionFactory.fecharConexo(null, null);
			}
			s = 0;
			do{
				try{
					System.out.println ("Deseja realizar outra simulao?");
					s = Integer.parseInt(intabela.nextLine());
					if (s!=1 && s!=2){
						System.out.println ("Opo no disponvel");
					}
				}catch (Exception e){
					System.out.println ("Opo no suportada pelo sistema.");
					intabela.next();
				}
			}while (s!= 1 && s!=2);
		} while (s!= 2);
		Principal.main(null);
	}

}
