package org.util.dao;

import java.awt.Desktop;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.InputMismatchException;
import java.util.Locale;
import java.util.Scanner;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import org.util.Principal.Principal;
import org.util.cliente.Cliente;
import org.util.cliente.Financiamento;
import org.util.cliente.TabelaSAC;
import org.util.conexoJDBC.ConnectionFactory;

import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Element;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.pdf.PdfPCell;
import com.itextpdf.text.pdf.PdfPTable;
import com.itextpdf.text.pdf.PdfWriter;


public class JDBCTabelaSACDAO implements TabelaSACDAO{

	private Connection connection;

	private int s = 0;

	private String sql = null;
	private String termoPesquisa = null;

	Scanner intabela = new Scanner (System.in);
	Locale local = Locale.getDefault();
	NumberFormat nForm = NumberFormat.getCurrencyInstance(local);
	DecimalFormat nPerc = new DecimalFormat("0.00");
	JFileChooser arquivo = new JFileChooser ();
	Financiamento finan = new Financiamento ();

	Cliente cliente = new Cliente ();
	TabelaSAC sac = new TabelaSAC();
	PdfPTable table = new PdfPTable (6);


	public JDBCTabelaSACDAO(){
		this.connection = ConnectionFactory.getConnection();
	}

	@Override
	public void calcularTabela() {
		do{
			// Simulao da Tabela SAC.
			do {
				try{
					System.out.println ("Selecione o Mtodo de Consulta"
							+ "\n1 - Nome | 2 - CPF");
					s = Integer.parseInt(intabela.nextLine());
					if (s != 1 && s != 2){
						System.out.println ("Tipo de pesquisa invlido. ");
					}
				} catch (InputMismatchException e){
					System.out.println ("Tipo de dado no suportado.");
				}
			}while (s != 1 && s != 2);
			if (s == 1){
				System.out.println ("Informe o nome do cliente.");
				termoPesquisa = intabela.nextLine();
				sql = "SELECT nome, cpf, categoria, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
						+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
						+ "WHERE nome ILIKE '%" + termoPesquisa + "%'\n"
						+ "AND Pesquisa.idCliente = Cliente.id\n"
						+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
						+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
			} else {
				System.out.println ("Informe o CPF do cliente.");
				termoPesquisa = intabela.nextLine();
				sql = "SELECT nome, cpf, categoria, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
						+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
						+ "WHERE cpf ILIKE '%" + termoPesquisa + "%'\n"
						+ "AND Pesquisa.idCliente = Cliente.id\n"
						+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
						+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
			}

			Connection connection = null;
			PreparedStatement psSelect = null;
			PreparedStatement psInsert = null;
			ResultSet rsSelect = null;

			try{
				connection = this.connection;
				psSelect = connection.prepareStatement(sql);
				psInsert = connection.prepareStatement(sql);
				rsSelect = psSelect.executeQuery();

				while (rsSelect.next()){
					cliente.setNome(rsSelect.getString("nome"));
					cliente.setCpf(rsSelect.getString("cpf"));
					cliente.setCategoria(rsSelect.getString("categoria"));
					sac.setSaldoDevedor(rsSelect.getDouble("valorFinanciar"));
					sac.setParcela(rsSelect.getInt("parcelas"));
					sac.setValorMaximoParcela(rsSelect.getDouble("restanteMargemConsignavel"));
					sac.setCategoriaCliente(rsSelect.getString("categoria"));
				}
				s = 0;
				do{
					try{
						System.out.println ("Taxa de juros a utilizar: "
								+ "1 - Personalizado | 2 - Por Categoria");
						s = Integer.parseInt(intabela.nextLine());
					}catch (InputMismatchException e){
						System.out.println ("Tipo de dado no corresponde  informao solicitada.");
						intabela.next();
					}
					if(s!=1 && s!=2){
						System.out.println ("Taxa de juros no compatvel para simulao.");
					}
				}while (s!=1 && s!=2);

				sac.setJurosDevedor(-1);
				if (s == 1){
					do{
						try {
							System.out.println ("Taxa de juros: ");
							sac.setJurosDevedor(intabela.nextDouble() / 100);
						} catch (InputMismatchException e){
							System.out.println ("Formato digitado no suportado.");
							intabela.next();
						}
						sql = "UPDATE Financiamento " + "SET taxaJuros = ?" + "Where id = " + cliente.getId();
						try {
							connection = this.connection;
							psInsert = connection.prepareStatement (sql);
							psInsert.setDouble (1, sac.getJurosDevedor());
						} catch (SQLException e){
							System.out.println ("Erro na insero de dados - Classe JDBCTabelaSACDAO");
							System.out.println ("Descrio: " + e.getMessage());
						}
						psInsert.executeUpdate();
					}while (sac.getJurosDevedor() < 0);
				} else {
					if(sac.getCategoriaCliente().equalsIgnoreCase("Servidor Pblico")){
						sac.setJurosDevedor(1.80 / 100);
					} else if(sac.getCategoriaCliente().equalsIgnoreCase("Pensionista")){
						sac.setJurosDevedor(1.90 / 100);
					} else if(sac.getCategoriaCliente().equalsIgnoreCase("Aposentado")){
						sac.setJurosDevedor(1.70 / 100);
					}
				}

				sac.setAmortizacao(sac.getSaldoDevedor() / sac.getParcela());
				sac.setValorParcela(sac.getValorJuro() + sac.getAmortizacao());
				s = 0;
				try{
					if (sac.getValorParcela() > sac.getValorMaximoParcela()){
						System.out.println ("Valor da parcela, para o valor solicitado, excede o mximo permitido para o contrato."
								+ "\nDeseja alterar os dados?"
								+ "\n1 - Sim | 2 - No");
						s = Integer.parseInt(intabela.nextLine());
					}
				}catch (Exception e){
					System.out.println ("Tipo de informao no compatvel com o dado solicitado");
					intabela.next();
				}
				do{
					if (s == 1){
						try{
							System.out.println ("Valor a financiar: ");
							finan.setValorFinanciar(Double.parseDouble(intabela.nextLine()));
							sql = "UPDATE Financiamento " + "SET valorFinanciar = ?" + "Where id = " + cliente.getId();
							try {
								connection = this.connection;
								psInsert = connection.prepareStatement (sql);
								psInsert.setDouble (1, finan.getValorFinanciar());
							} catch (SQLException e){
								System.out.println ("Erro na insero de dados - Classe JDBCTabelaSACDAO");
								System.out.println ("Descrio: " + e.getMessage());
							}
							psInsert.executeUpdate();
							sac.setSaldoDevedor(finan.getValorFinanciar());

							System.out.println ("Nmero de parcelas: ");
							finan.setParcelas(Integer.parseInt(intabela.nextLine()));
							sql = "UPDATE Financiamento " + "SET parcelas = ?" + "Where id = " + cliente.getId();
							try {
								connection = this.connection;
								psInsert = connection.prepareStatement (sql);
								psInsert.setInt (1, sac.getParcela());
							} catch (SQLException e){
								System.out.println ("Erro na insero de dados - Classe JDBCTabelaSACDAO");
								System.out.println ("Descrio: " + e.getMessage());
							}
							psInsert.executeUpdate();
							sac.setParcela(finan.getParcelas());

						}catch (Exception e){
							System.out.println ("Erro na Insero dos dados.");
						}
					}

					sac.setAmortizacao(sac.getSaldoDevedor() / sac.getParcela());
					sac.setValorParcela(sac.getValorJuro() + sac.getAmortizacao());
					s = 0;
					try{
						if (sac.getValorParcela() > sac.getValorMaximoParcela()){
							System.out.println ("Valor da parcela, para o valor solicitado, excede o mximo permitido para o contrato."
									+ "\nDeseja alterar os dados?"
									+ "\n1 - Sim | 2 - No");
							s = Integer.parseInt(intabela.nextLine());
						} else {
							s = 2;
						}
					}catch (Exception e){
						System.out.println ("Tipo de informao no compatvel com o dado solicitado");
						intabela.next();
					}
				} while (s!=2);

				if ((sac.getValorParcela() < sac.getValorMaximoParcela())){
					try{
						Document docsac = new Document (PageSize.A4);
						PdfWriter.getInstance(docsac, new FileOutputStream("Tabela SAC.pdf"));
						docsac.open();
						System.out.println ("Gerando simulao - Modelo SAC");


						PdfPCell header = new PdfPCell(new Paragraph ("Simulao - Tabela SAC" + "\nCliente: " + cliente.getNome()
								+ "\nC.P.F.: " + cliente.getCpf() + " | Categoria: " + cliente.getCategoria()
								+ "\n========================================================="
								+ "\nTaxa de Juros: " + nPerc.format((sac.getJurosDevedor() * 100)) + "% | Prazo: " + sac.getParcela() + " meses."));
						header.setHorizontalAlignment(Element.ALIGN_CENTER);
						header.setColspan(6);
						table.addCell(header);

						table.setHorizontalAlignment(Element.ALIGN_CENTER);
						table.addCell("Prestao");
						table.addCell("Valor Contratado");
						table.addCell("Valor da Parcela");
						table.addCell("Amort.");
						table.addCell("Valor dos Juros");
						table.addCell("Saldo Devedor");

						for (int i = 1; i <= sac.getParcela(); i++){
							sac.setValorJuro(sac.getSaldoDevedor() * sac.getJurosDevedor());
							sac.setValorParcela(sac.getValorJuro() + sac.getAmortizacao());
							sac.setSaldoPosterior(sac.getSaldoDevedor() - sac.getAmortizacao());

							table.addCell(String.valueOf(i));
							table.addCell(String.valueOf(nForm.format(sac.getSaldoDevedor())));
							table.addCell(String.valueOf(nForm.format(sac.getValorParcela())));
							table.addCell(String.valueOf(nForm.format(sac.getAmortizacao())));
							table.addCell(String.valueOf(nForm.format(sac.getValorJuro())));
							table.addCell(String.valueOf(nForm.format(sac.getSaldoPosterior())));

							sac.setSaldoDevedor(sac.getSaldoDevedor() - sac.getAmortizacao());
						}
						docsac.add(table);
						docsac.close();
						s = 0;
						do {
							try{
								System.out.println ("Simulao gerada com sucesso. Deseja abrir simulao?"
										+ "\n1 - Sim | 2 - No");
								s = Integer.parseInt(intabela.nextLine());
								if (s!= 1 && s!= 2){
									System.out.println ("Opo no disponvel");
								}
							} catch (Exception e){
								System.out.println ("Tipo de opo no suportado");
								intabela.next();
							}
						}while (s!= 1 && s!= 2);
						if (s == 1) {
							try{
								File pdf = new File ("Tabela SAC.pdf");
								Desktop.getDesktop().open(pdf);
							} catch (Exception ex){
								ex.printStackTrace();
								JOptionPane.showMessageDialog(null, "Erro no Desktop" + ex);
							}
						}

					}catch (DocumentException de) {
						System.err.println(de.getMessage());
					} 
					catch (IOException ioe) {
						System.err.println(ioe.getMessage());
					}
				}

			} catch (SQLException e){
				System.out.println ("Erro na manipulao de dados - Classe JDBCTabelaSACDAO");
				System.out.println ("Descrio: " + e.getMessage());
			} finally{
				ConnectionFactory.fecharConexo(null, null);
			}
			s = 0;
			do{
				try{
					System.out.println ("Deseja realizar outra simulao?");
					s = Integer.parseInt(intabela.nextLine());
					if (s!=1 && s!=2){
						System.out.println ("Opo no disponvel");
					}
				}catch (Exception e){
					System.out.println ("Opo no suportada pelo sistema.");
					intabela.next();
				}
			}while (s!= 1 && s!=2);
		} while (s!= 2);
		Principal.main(null);
	}

	@Override
	public void calcularParcela() {
		// TODO Auto-generated method stub
		do{
			do {
				try{
					System.out.println ("Selecione o Mtodo de Consulta"
							+ "\n1 - Nome | 2 - CPF");
					s = Integer.parseInt(intabela.nextLine());
					if (s != 1 && s != 2){
						System.out.println ("Tipo de pesquisa invlido. ");
					}
				} catch (InputMismatchException e){
					System.out.println ("Tipo de dado no suportado.");
				}
			}while (s != 1 && s != 2);
			if (s == 1){
				System.out.println ("Informe o nome do cliente.");
				termoPesquisa = intabela.nextLine();
				sql = "SELECT nome, cpf, categoria, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
						+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
						+ "WHERE nome ILIKE '%" + termoPesquisa + "%'\n"
						+ "AND Pesquisa.idCliente = Cliente.id\n"
						+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
						+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
			} else {
				System.out.println ("Informe o CPF do cliente.");
				termoPesquisa = intabela.nextLine();
				sql = "SELECT nome, cpf, categoria, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
						+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
						+ "WHERE cpf ILIKE '%" + termoPesquisa + "%'\n"
						+ "AND Pesquisa.idCliente = Cliente.id\n"
						+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
						+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
			}

			Connection connection = null;
			PreparedStatement psSelect = null;
			ResultSet rsSelect = null;

			try{
				connection = this.connection;
				psSelect = connection.prepareStatement(sql);
				rsSelect = psSelect.executeQuery();

				while (rsSelect.next()){
					cliente.setNome(rsSelect.getString("nome"));
					cliente.setCpf(rsSelect.getString("cpf"));
					cliente.setCategoria(rsSelect.getString("categoria"));
					sac.setSaldoDevedor(rsSelect.getDouble("valorFinanciar"));
					sac.setTotalParcelas(rsSelect.getInt("parcelas"));
					sac.setValorMaximoParcela(rsSelect.getDouble("restanteMargemConsignavel"));
					sac.setCategoriaCliente(rsSelect.getString("categoria"));
				}

				if(sac.getCategoriaCliente().equalsIgnoreCase("Servidor Pblico")){
					sac.setJurosDevedor(1.80 / 100);
				} else if(sac.getCategoriaCliente().equalsIgnoreCase("Pensionista")){
					sac.setJurosDevedor(1.90 / 100);
				} else if(sac.getCategoriaCliente().equalsIgnoreCase("Aposentado")){
					sac.setJurosDevedor(1.70 / 100);
				}
				System.out.println ("Informe o total de parcelas pagas: ");
				sac.setParcela (intabela.nextInt());

				sac.setSaldoPosterior(sac.getSaldoDevedor() * (1 - (((sac.getParcela() - 1) * 1.0) / sac.getTotalParcelas())));
				System.out.println (sac.getSaldoPosterior());
				sac.setValorParcela((sac.getSaldoDevedor() / ((sac.getTotalParcelas() * 1.0)) + (sac.getSaldoPosterior() * sac.getJurosDevedor())));

				System.out.println ("Cliente: " + cliente.getNome()
						+ "\nC.P.F.: " + cliente.getCpf() + " | Categoria: " + cliente.getCategoria()
						+ "\n----------------------------------------------------------------------------");
				System.out.println ("Valor da Prxima Prestao");
				System.out.println ("Parcela do : " + sac.getParcela() + " ms: " + nForm.format(sac.getValorParcela())
						+ "\n----------------------------------------------------------------------------");

			} catch (SQLException e){
				System.out.println ("Erro na manipulao de dados - Classe JDBCTabelaSACDAO");
				System.out.println ("Descrio: " + e.getMessage());
			} finally{
				ConnectionFactory.fecharConexo(null, null);
			}
			s = 0;
			do{
				try{
					System.out.println ("Deseja realizar outra consulta?");
					s = Integer.parseInt(intabela.nextLine());
					if (s!=1 && s!=2){
						System.out.println ("Opo no disponvel");
					}
				}catch (Exception e){
					System.out.println ("Opo no suportada pelo sistema.");
					intabela.next();
				}
			}while (s!= 1 && s!=2);
		} while (s!= 2);
		Principal.main(null);
	}

	@Override
	public void SaldoDevedor() {
		// TODO Auto-generated method stub
		do{
			do {
				try{
					System.out.println ("Selecione o Mtodo de Consulta"
							+ "\n1 - Nome | 2 - CPF");
					s = Integer.parseInt(intabela.nextLine());
					if (s != 1 && s != 2){
						System.out.println ("Tipo de pesquisa invlido. ");
					}
				} catch (InputMismatchException e){
					System.out.println ("Tipo de dado no suportado.");
				}
			}while (s != 1 && s != 2);
			if (s == 1){
				System.out.println ("Informe o nome do cliente.");
				termoPesquisa = intabela.nextLine();
				sql = "SELECT nome, cpf, categoria, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
						+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
						+ "WHERE nome ILIKE '%" + termoPesquisa + "%'\n"
						+ "AND Pesquisa.idCliente = Cliente.id\n"
						+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
						+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
			} else {
				System.out.println ("Informe o CPF do cliente.");
				termoPesquisa = intabela.nextLine();
				sql = "SELECT nome, cpf, categoria, restanteMargemConsignavel, valorFinanciar, parcelas\n" 
						+ "FROM Cliente, DadosFinanceiros, Financiamento, Pesquisa\n"
						+ "WHERE cpf ILIKE '%" + termoPesquisa + "%'\n"
						+ "AND Pesquisa.idCliente = Cliente.id\n"
						+ "AND Pesquisa.idDadosFinanceiros = DadosFinanceiros.id\n"
						+ "AND Pesquisa.idFinanciamento = Financiamento.id\n";
			}

			Connection connection = null;
			PreparedStatement psSelect = null;
			ResultSet rsSelect = null;

			try{
				connection = this.connection;
				psSelect = connection.prepareStatement(sql);
				rsSelect = psSelect.executeQuery();

				while (rsSelect.next()){
					cliente.setNome(rsSelect.getString("nome"));
					cliente.setCpf(rsSelect.getString("cpf"));
					cliente.setCategoria(rsSelect.getString("categoria"));
					sac.setSaldoDevedor(rsSelect.getDouble("valorFinanciar"));
					sac.setTotalParcelas(rsSelect.getInt("parcelas"));
					sac.setValorMaximoParcela(rsSelect.getDouble("restanteMargemConsignavel"));
					sac.setCategoriaCliente(rsSelect.getString("categoria"));
				}

				if(sac.getCategoriaCliente().equalsIgnoreCase("Ativo")){
					sac.setJurosDevedor(1.80 / 100);
				} else if(sac.getCategoriaCliente().equalsIgnoreCase("Pensionista")){
					sac.setJurosDevedor(1.90 / 100);
				} else if(sac.getCategoriaCliente().equalsIgnoreCase("Aposentado")){
					sac.setJurosDevedor(1.70 / 100);
				}
				System.out.println ("Informe o total de parcelas pagas: ");
				sac.setParcela (intabela.nextInt());
				System.out.println (sac.getParcela());
				System.out.println (sac.getSaldoDevedor());
				System.out.println (sac.getTotalParcelas());

				sac.setSaldoPosterior(sac.getSaldoDevedor() * (1 - ((sac.getParcela() * 1.0) / sac.getTotalParcelas())));

				System.out.println ("Cliente: " + cliente.getNome()
						+ "\nC.P.F.: " + cliente.getCpf() + " | Categoria: " + cliente.getCategoria()
						+ "\n----------------------------------------------------------------------------");
				System.out.println ("Resultado da consulta");
				System.out.println ("Saldo Devedor: " + nForm.format(sac.getSaldoPosterior())
						+ "\n----------------------------------------------------------------------------");
			} catch (SQLException e){
				System.out.println ("Erro na manipulao de dados - Classe JDBCTabelaSACDAO");
				System.out.println ("Descrio: " + e.getMessage());
			} finally{
				ConnectionFactory.fecharConexo(null, null);
			}
			s = 0;
			do{
				try{
					System.out.println ("Deseja realizar outra consulta?");
					s = Integer.parseInt(intabela.nextLine());
					if (s!=1 && s!=2){
						System.out.println ("Opo no disponvel");
					}
				}catch (Exception e){
					System.out.println ("Opo no suportada pelo sistema.");
					intabela.next();
				}
			}while (s!= 1 && s!=2);
		} while (s!= 2);
		Principal.main(null);
	}
}
